- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# sbuild::chroot_block_device Class Reference

A chroot stored on an unmounted block device. More...

`#include <sbuild-chroot-block-device.h>`

Inheritance diagram for sbuild::chroot_block_device:

[legend]
Collaboration diagram for sbuild::chroot_block_device:

[legend]
List of all members.

## Public Member Functions
virtual | ~chroot_block_device ()
| The destructor.
virtual chroot::ptr | clone () const
| Copy the chroot.
std::string const & | get_device () const
| Get the block device of the chroot.
void | set_device (std::string const &device)
| Set the block device of the chroot.
virtual std::string const & | get_mount_device () const
| Get the mount device of the chroot.
std::string const & | get_mount_options () const
| Get the filesystem mount_options of the chroot block device.
void | set_mount_options (std::string const &mount_options)
| Set the filesystem mount_options of the chroot block device.
virtual std::string const & | get_location () const
| Get the location.
virtual void | set_location (std::string const &location)
| Set the location.
virtual std::string const & | get_chroot_type () const
| Get the type of the chroot.
virtual void | setup_env (environment &env)
| Set environment.
virtual session_flags | get_session_flags () const
| Get the session flags of the chroot.
## Protected Member Functions
| chroot_block_device ()
| The constructor.
virtual void | setup_lock (chroot::setup_type type, bool lock, int status)
| Unlock a chroot during setup.
virtual void | get_details (format_detail &detail) const
| Get detailed information about the chroot for output.
virtual void | get_keyfile (keyfile &keyfile) const
| Copy the chroot properties into a keyfile.
virtual void | set_keyfile (keyfile const &keyfile)
| Set the chroot properties from a keyfile.
## Private Attributes
std::string | device
| The block device to use.
std::string | mount_options
| The options to mount the device with.
## Friends
class | chroot

## Detailed Description

A chroot stored on an unmounted block device.

The device will be mounted on demand.

## Constructor & Destructor Documentation

chroot_block_device::chroot_block_device | ( |  | ) | `[protected]`

The constructor.

chroot_block_device::~chroot_block_device | ( |  | ) | `[virtual]`

The destructor.

## Member Function Documentation

sbuild::chroot::ptr chroot_block_device::clone | ( |  | ) | const`[virtual]`

Copy the chroot.

This is a virtual copy constructor.

Returns:
  a shared_ptr to the new copy of the chroot.

Implements sbuild::chroot.

Reimplemented in sbuild::chroot_lvm_snapshot.

std::string const & chroot_block_device::get_chroot_type | ( |  | ) | const`[virtual]`

Get the type of the chroot.

Returns:
  the chroot type.

Implements sbuild::chroot.

Reimplemented in sbuild::chroot_lvm_snapshot.

void chroot_block_device::get_details | ( | format_detail & | detail | ) | const`[protected, virtual]`

Get detailed information about the chroot for output.

Parameters:

  | detail | the details to output to.

Reimplemented from sbuild::chroot.

Reimplemented in sbuild::chroot_lvm_snapshot.

std::string const & chroot_block_device::get_device | ( |  | ) | const

Get the block device of the chroot.

Returns:
  the device.

void chroot_block_device::get_keyfile | ( | keyfile & | keyfile | ) | const`[protected, virtual]`

Copy the chroot properties into a keyfile.

The keyfile group with the name of the chroot will be set; if it already exists, it will be removed before setting it.

Parameters:

  | keyfile | the keyfile to use.

Reimplemented from sbuild::chroot.

Reimplemented in sbuild::chroot_lvm_snapshot.

std::string const & chroot_block_device::get_location | ( |  | ) | const`[virtual]`

Get the location.

This is a path to the chroot directory inside the LV (absolute path from the LV root).

Returns:
  the location.

Reimplemented from sbuild::chroot.

std::string const & chroot_block_device::get_mount_device | ( |  | ) | const`[virtual]`

Get the mount device of the chroot.

Returns:
  the device.

Reimplemented from sbuild::chroot.

Reimplemented in sbuild::chroot_lvm_snapshot.

std::string const & chroot_block_device::get_mount_options | ( |  | ) | const

Get the filesystem mount_options of the chroot block device.

Returns:
  the mount options.

sbuild::chroot::session_flags chroot_block_device::get_session_flags | ( |  | ) | const`[virtual]`

Get the session flags of the chroot.

These determine how the Session controlling the chroot will operate.

Returns:
  the session flags.

Implements sbuild::chroot.

Reimplemented in sbuild::chroot_lvm_snapshot.

void chroot_block_device::set_device | ( | std::string const & | device | ) |

Set the block device of the chroot.

This is the "source" device. It may be the case that the real device is different (for example, an LVM snapshot PV), but by default will be the device to mount.

Parameters:

  | device | the device.

void chroot_block_device::set_keyfile | ( | keyfile const & | keyfile | ) | `[protected, virtual]`

Set the chroot properties from a keyfile.

The chroot name must have previously been set, so that the correct keyfile group may be determined.

Parameters:

  | keyfile | the keyfile to get the properties from.

Reimplemented from sbuild::chroot.

Reimplemented in sbuild::chroot_lvm_snapshot.

void chroot_block_device::set_location | ( | std::string const & | location | ) | `[virtual]`

Set the location.

This is a path to the chroot directory inside the LV (absolute path from the LV root).

Parameters:

  | location | the location.

Reimplemented from sbuild::chroot.

void chroot_block_device::set_mount_options | ( | std::string const & | mount_options | ) |

Set the filesystem mount_options of the chroot block device.

Parameters:

  | mount_options | the mount options.

void chroot_block_device::setup_env | ( | environment & | env | ) | `[virtual]`

Set environment.

Set the environment that the setup scripts will see during execution.

Parameters:

  | env | the environment to set.

Reimplemented from sbuild::chroot.

Reimplemented in sbuild::chroot_lvm_snapshot.

void chroot_block_device::setup_lock | ( | chroot::setup_type | type,
|  | bool | lock,
|  | int | status |
| ) |  |  | `[protected, virtual]`

Unlock a chroot during setup.

The locking technique (if any) may vary depending upon the chroot type and setup stage. For example, during creation of an LVM snapshot a block device might require locking, but afterwards this will change to the new block device.

An error will be thrown on failure.

Parameters:

  | type | the type of setup being performed
  | lock | true to lock, false to unlock
  | status | the exit status of the setup commands (0 for success, nonzero for failure).

Implements sbuild::chroot.

Reimplemented in sbuild::chroot_lvm_snapshot.

## Friends And Related Function Documentation

friend class chroot`[friend]`

Reimplemented in sbuild::chroot_lvm_snapshot.

## Member Data Documentation

std::string sbuild::chroot_block_device::device`[private]`

The block device to use.

std::string sbuild::chroot_block_device::mount_options`[private]`

The options to mount the device with.

The documentation for this class was generated from the following files:

- sbuild/sbuild-chroot-block-device.h
- sbuild/sbuild-chroot-block-device.cc